=== added file 'src/com/goldencode/p2j/ui/ControlEntityExt.java'
--- src/com/goldencode/p2j/ui/ControlEntityExt.java	1970-01-01 00:00:00 +0000
+++ src/com/goldencode/p2j/ui/ControlEntityExt.java	2020-02-25 16:18:50 +0000
@@ -0,0 +1,783 @@
+/*
+** Module   : ControlEntityExt.java
+** Abstract : Implements WidgetExtension
+**
+** Copyright (c) 2020, Golden Code Development Corporation.
+**
+** -#- -I- --Date-- ---------------------------------Description---------------------------------
+** 001 SBI 20200223 Created initial version.
+*/
+
+/*
+** This program is free software: you can redistribute it and/or modify
+** it under the terms of the GNU Affero General Public License as
+** published by the Free Software Foundation, either version 3 of the
+** License, or (at your option) any later version.
+**
+** This program is distributed in the hope that it will be useful,
+** but WITHOUT ANY WARRANTY; without even the implied warranty of
+** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+** GNU Affero General Public License for more details.
+**
+** You may find a copy of the GNU Affero GPL version 3 at the following
+** location: https://www.gnu.org/licenses/agpl-3.0.en.html
+** 
+** Additional terms under GNU Affero GPL version 3 section 7:
+** 
+**   Under Section 7 of the GNU Affero GPL version 3, the following additional
+**   terms apply to the works covered under the License.  These additional terms
+**   are non-permissive additional terms allowed under Section 7 of the GNU
+**   Affero GPL version 3 and may not be removed by you.
+** 
+**   0. Attribution Requirement.
+** 
+**     You must preserve all legal notices or author attributions in the covered
+**     work or Appropriate Legal Notices displayed by works containing the covered
+**     work.  You may not remove from the covered work any author or developer
+**     credit already included within the covered work.
+** 
+**   1. No License To Use Trademarks.
+** 
+**     This license does not grant any license or rights to use the trademarks
+**     Golden Code, FWD, any Golden Code or FWD logo, or any other trademarks
+**     of Golden Code Development Corporation. You are not authorized to use the
+**     name Golden Code, FWD, or the names of any author or contributor, for
+**     publicity purposes without written authorization.
+** 
+**   2. No Misrepresentation of Affiliation.
+** 
+**     You may not represent yourself as Golden Code Development Corporation or FWD.
+** 
+**     You may not represent yourself for publicity purposes as associated with
+**     Golden Code Development Corporation, FWD, or any author or contributor to
+**     the covered work, without written authorization.
+** 
+**   3. No Misrepresentation of Source or Origin.
+** 
+**     You may not represent the covered work as solely your work.  All modified
+**     versions of the covered work must be marked in a reasonable way to make it
+**     clear that the modified work is not originating from Golden Code Development
+**     Corporation or FWD.  All modified versions must contain the notices of
+**     attribution required in this license.
+*/
+
+
+package com.goldencode.p2j.ui;
+
+
+import com.goldencode.p2j.ui.ocx.DataObject;
+import com.goldencode.p2j.ui.ocx.IVBDataObject;
+import com.goldencode.p2j.util.*;
+
+import static com.goldencode.p2j.ui.WidgetConfigExt.*;
+import static com.goldencode.p2j.ui.ocx.IVBDataObject.CF_BITMAP;
+import static com.goldencode.p2j.ui.ocx.IVBDataObject.CF_DIB;
+import static com.goldencode.p2j.ui.ocx.IVBDataObject.CF_EMETAFILE;
+import static com.goldencode.p2j.ui.ocx.IVBDataObject.CF_FILES;
+import static com.goldencode.p2j.ui.ocx.IVBDataObject.CF_METAFILE;
+import static com.goldencode.p2j.ui.ocx.IVBDataObject.CF_PALETTE;
+import static com.goldencode.p2j.ui.ocx.IVBDataObject.CF_RTF;
+import static com.goldencode.p2j.ui.ocx.IVBDataObject.CF_TEXT;
+import static com.goldencode.p2j.ui.ocx.IVBDataObject.COPY;
+import static com.goldencode.p2j.ui.ocx.IVBDataObject.DROP_MANUAL;
+import static com.goldencode.p2j.ui.ocx.IVBDataObject.DROP_NONE;
+import static com.goldencode.p2j.ui.ocx.IVBDataObject.MOVE;
+import static com.goldencode.p2j.ui.ocx.IVBDataObject.NONE;
+import static com.goldencode.p2j.ui.ocx.IVBDataObject.SCROLL;
+import static com.goldencode.p2j.util.Utils.isValidValue;
+
+/**
+ * Implements WidgetExtension.
+ * 
+ * @param    <T>
+ *           Data type that extends WidgetConfigExt
+ */
+public class ControlEntityExt<T extends WidgetConfigExt>
+extends ControlEntity<T>
+implements WidgetExtension,
+           ComData,
+           OcxMouse,
+           OcxDragDrop
+{
+   /** Com data */
+   protected comhandle comData;
+   
+   /**
+    * Creates this instance
+    * 
+    * @param    dynamic
+    *           Indicates that widget is not static
+    * @param    ctrl
+    *           The given widget configuration
+    */
+   public ControlEntityExt(boolean dynamic, T ctrl)
+   {
+      super(dynamic, ctrl);
+      
+      comData = DataObject.newInstance(this);
+   }
+
+   /**
+    * Gets the type of mouse pointer displayed when over part of an object.
+    * 
+    * @return mouse pointer
+    */
+   @Override
+   public integer getMousePointerNum()
+   {
+      return new integer(config.mousePointer);
+   }
+
+   /**
+    * Sets the type of mouse pointer displayed when over part of an object.
+    * 
+    * @param   value
+    *          new mouse pointer
+    */
+   @Override
+   public void setMousePointerNum(integer value)
+   {
+      if (value.isUnknown())
+      {
+         ErrorManager.recordOrShowError(4083, String.format(
+               "Unable to assign UNKNOWN value to attribute MOUSE-POINTER on %s %s", type(),
+                  widgetName()), false);
+      }
+      else
+      {
+         setMousePointerNum(value.intValue());
+      }
+   }
+
+   /**
+    * Sets the type of mouse pointer displayed when over part of an object.
+    * 
+    * @param   value
+    *          new mouse pointer
+    */
+   @Override
+   public void setMousePointerNum(int value)
+   {
+      if (config.mousePointer == value)
+      {
+         return;
+      }
+      
+      if (Utils.isValidValue(value, CC_DEFAULT, CC_ARROW, CC_CROSS, CC_IBEAM, CC_ICON, CC_SIZE,
+               CC_SIZE_NESW, CC_SIZE_NS, CC_SIZE_NWSE, CC_SIZE_EW, CC_UP_ARROW,  CC_HOURGLASS,
+               CC_NO_DROP, CC_ARROW_HOURGLASS, CC_ARROW_QUESTION, CC_SIZE_ALL, CC_CUSTOM))
+      {
+         config.mousePointer = value;
+         pushWidgetAttr("mousePointer", config.mousePointer);
+      }
+      else
+      {
+         ErrorManager.recordOrShowError(5990, String.format(
+                  "Error occured while accessing component property/method: MousePointer\n"
+                  + "Invalid property value\n%s %s", type(), widgetName()), true);                     
+      }            
+   }
+
+   /**
+    * Gets a mouse icon for this control.
+    * 
+    * @return   The mouse icon for this control
+    */
+   @Override
+   public character getMouseIcon()
+   {
+      return new character(config.mouseIcon);
+   }
+
+   /**
+    * Sets a custom mouse icon for this control.
+    * 
+    * @param   value
+    *          The user defined mouse icon
+    */
+   @Override
+   public void setMouseIcon(character value)
+   {
+      if (value.isUnknown())
+      {
+         ErrorManager.recordOrShowError(4083, String.format(
+               "Unable to assign UNKNOWN value to attribute MOUSE-ICON on %s %s", type(),
+                  widgetName()), false);
+      }
+      else
+      {
+         setMouseIcon(value.getValue());
+      }
+   }
+
+   /**
+    * Sets a custom mouse icon for this control.
+    * 
+    * @param   value
+    *          The user defined mouse icon
+    */
+   @Override
+   public void setMouseIcon(String value)
+   {
+      if (!config.realized)
+      {
+         if (config.mouseIcon == value)
+         {
+            return;
+         }
+         
+         config.mouseIcon = value;
+         pushWidgetAttr("mouseIcon", config.mouseIcon);
+      }
+      else
+      {
+         ErrorManager.recordOrShowError(4053, String.format(
+               "Unable to set MOUSE-ICON because the %s %s has been realised", type(),
+                  widgetName()), false);
+      }
+   }
+
+   /**
+    * Forces a complete repaint of a form or control.
+    */
+   @Override
+   public void refreshUI()
+   {
+      LogicalTerminal.refreshWidget(config.id.asInt());
+   }
+
+   /**
+    * Return whether this control can act as an OLE drop target.
+    * OLEDropConstants - ccOLEDropManual=1 ccOLEDropNone=0
+    * 
+    * @return   The OLE drop mode
+    */
+   @Override
+   public integer getOleDropMode()
+   {
+      return new integer(config.oleDropMode);
+   }
+
+   /**
+    * Set whether this control can act as an OLE drop target.
+    * OLEDropConstants - ccOLEDropManual=1 ccOLEDropNone=0
+    * 
+    * @param    value
+    *           The OLE drop mode
+    */
+   @Override
+   public void setOleDropMode(integer value)
+   {
+      if (value.isUnknown())
+      {
+         ErrorManager.recordOrShowError(4083, String.format(
+               "Unable to assign UNKNOWN value to attribute OLE-DROP-MODE on %s %s", type(),
+                  widgetName()), false);
+      }
+      else
+      {
+         setOleDropMode(value.intValue());
+      }
+   }
+
+   /**
+    * Set whether this control can act as an OLE drop target.
+    * OLEDropConstants - ccOLEDropManual=1 ccOLEDropNone=0
+    * 
+    * @param    value 
+    *           The OLE drop mode
+    */
+   @Override
+   public void setOleDropMode(int value)
+   {
+      super.setDropTarget(value == IVBDataObject.DROP_MANUAL);
+      
+      if (config.oleDropMode == value)
+      {
+         return;
+      }
+      
+      if (isValidValue(value, DROP_MANUAL, DROP_NONE))
+      {         
+         config.oleDropMode = value;
+         pushWidgetAttr("oleDropMode", config.oleDropMode);
+      }
+      else
+      {
+         ErrorManager.recordOrShowError(5990, String.format(
+                  "Error occured while accessing component property/method: OLEDropMode\n"
+                  + "Invalid property value\n%s %s", type(), widgetName()), true);                     
+      }
+   }
+
+   /**
+    * Start an OLE drag/drop event with the given control as the source.
+    */
+   @Override
+   public void oleDrag()
+   {
+      LogicalTerminal.oleDrag(config.id.asInt());
+   }
+
+   /**
+    * Get the drag and drop mouse effect.
+    * 
+    * @return   The drag and drop mouse effect
+    */
+   @Override
+   public integer getEffect()
+   {
+      return new integer(config.oleEffect);
+   }
+
+   /**
+    * Set the drag and drop mouse effect.
+    * 
+    * @param    value
+    *           The drag and drop mouse effect
+    */
+   @Override
+   public void setEffect(integer value)
+   {
+      if (value.isUnknown())
+      {
+         ErrorManager.recordOrShowError(4083, String.format(
+               "Unable to assign UNKNOWN value to attribute OLE-EFFECT on %s %s", type(),
+                  widgetName()), false);
+      }
+      else
+      {
+         setEffect(value.intValue());
+      }
+   }
+
+   /**
+    * Set the drag and drop mouse effect.
+    * 
+    * @param    value
+    *           The drag and drop mouse effect
+    */
+     @Override
+   public void setEffect(int value)
+   {
+      if (config.oleEffect == value)
+      {
+         return;
+      }
+      
+      if (isValidValue(value, NONE, COPY, MOVE, SCROLL))
+      {
+         config.oleEffect = value;
+         pushWidgetAttr("oleEffect", config.oleEffect);
+      }
+      else
+      {
+         ErrorManager.recordOrShowError(5990, String.format(
+                  "Error occured while accessing component property/method: Effect\n"
+                  + "Invalid property value\n%s %s", type(), widgetName()), true);
+      }
+   }
+
+   /**
+    * Get the OLE X coordinate in character units.
+    * 
+    * @return   The OLE X coordinate
+    */
+   @Override
+   public decimal getOleX()
+   {
+      return new decimal(config.oleX);
+   }
+
+   /**
+    * Set the OLE X coordinate in character units.
+    * 
+    * @param   value
+    *          The OLE X coordinate
+    */
+   @Override
+   public void setOleX(decimal value)
+   {
+      if (value.isUnknown())
+      {
+         ErrorManager.recordOrShowError(4083, String.format(
+               "Unable to assign UNKNOWN value to attribute OLE-X on %s %s", type(),
+                  widgetName()), false);
+      }
+      else
+      {
+         setOleX(value.doubleValue());
+      }
+   }
+
+   /**
+    * Set the OLE X coordinate in character units.
+    * 
+    * @param   value
+    *          The OLE X coordinate
+    */
+   @Override
+   public void setOleX(double value)
+   {
+      if (!config.realized)
+      {
+         if (config.oleX == value)
+         {
+            return;
+         }
+         
+         config.oleX = value;
+         pushWidgetAttr("oleX", config.oleX);
+      }
+      else
+      {
+         ErrorManager.recordOrShowError(4053, String.format(
+               "Unable to set OLE-X because the %s %s has been realised", type(),
+                  widgetName()), false);
+      }
+   }
+
+   /**
+    * Get the OLE Y coordinate in character units.
+    * 
+    * @return   The OLE Y coordinate
+    */
+   @Override
+   public decimal getOleY()
+   {
+      return new decimal(config.oleY);
+   }
+
+   /**
+    * Set the OLE Y coordinate in character units.
+    * 
+    * @param    value
+    *           The OLE Y coordinate
+    */
+   @Override
+   public void setOleY(decimal value)
+   {
+      if (value.isUnknown())
+      {
+         ErrorManager.recordOrShowError(4083, String.format(
+               "Unable to assign UNKNOWN value to attribute OLE-Y on %s %s", type(),
+                  widgetName()), false);
+      }
+      else
+      {
+         setOleY(value.doubleValue());
+      }
+   }
+
+   /**
+    * Set the OLE Y coordinate in character units.
+    * 
+    * @param    value
+    *           The OLE Y coordinate
+    */
+   @Override
+   public void setOleY(double value)
+   {
+      if (!config.realized)
+      {
+         if (config.oleY == value)
+         {
+            return;
+         }
+         
+         config.oleY = value;
+         pushWidgetAttr("oleY", config.oleY);
+      }
+      else
+      {
+         ErrorManager.recordOrShowError(4053, String.format(
+               "Unable to set OLE-Y because the %s %s has been realised", type(),
+                  widgetName()), false);
+      }
+   }
+
+   /**
+    * Get the OLE state.
+    * 
+    * @return   The OLE state
+    */
+   @Override
+   public integer getState()
+   {
+      return new integer(config.state);
+   }
+
+   /**
+    * Set the OLE value state.
+    * 
+    * @param    value
+    *           The OLE state
+    */
+   @Override
+   public void setState(integer value)
+   {
+      if (value.isUnknown())
+      {
+         ErrorManager.recordOrShowError(4083, String.format(
+               "Unable to assign UNKNOWN value to attribute OLE-STATE on %s %s", type(),
+                  widgetName()), false);
+      }
+      else
+      {
+         setState(value.intValue());
+      }
+   }
+
+   /**
+    * Set the OLE value state.
+    * 
+    * @param    value
+    *           The OLE state
+    */
+   @Override
+   public void setState(int value)
+   {
+      if (config.oleState == value)
+      {
+         return;
+      }
+      
+      config.oleState = value;
+      pushWidgetAttr("oleState", config.oleState);
+   }
+
+   /**
+    * Tests if the default cursors are used.
+    * 
+    * @return   The default cursors flag
+    */
+   @Override
+   public logical isDefaultCursors()
+   {
+      return new logical(config.oleDefaultCursors);
+   }
+
+   /**
+    * Set the default cursors flag.
+    * 
+    * @param    value 
+    *           The default cursors flag
+    */
+   @Override
+   public void setDefaultCursors(logical value)
+   {
+      if (value.isUnknown())
+      {
+         ErrorManager.recordOrShowError(4083, String.format(
+               "Unable to assign UNKNOWN value to attribute DEFAULT-CURSORS on %s %s", type(),
+                  widgetName()), false);
+      }
+      else
+      {
+         setDefaultCursors(value.booleanValue());
+      }
+   }
+
+   /**
+    * Set the default cursors flag.
+    * 
+    * @param    value 
+    *           The default cursors flag
+    */
+   @Override
+   public void setDefaultCursors(boolean value)
+   {
+      if (config.oleDefaultCursors == value)
+      {
+         return;
+      }
+      
+      config.oleDefaultCursors = value;
+      pushWidgetAttr("oleDefaultCursors", config.oleDefaultCursors);
+   }
+
+   /**
+    * Get the data format.
+    * 
+    * @return   The data format
+    */
+   @Override
+   public integer getDataFormat()
+   {
+      return new integer(config.oleDataFormat);
+   }
+
+   /**
+    * Set the data format.
+    * 
+    * @param    value
+    *           The data format.
+    */
+   @Override
+   public void setDataFormat(integer value)
+   {
+      if (value.isUnknown())
+      {
+         ErrorManager.recordOrShowError(4083, String.format(
+               "Unable to assign UNKNOWN value to attribute DATA-FORMAT on %s %s", type(),
+                  widgetName()), false);
+      }
+      else
+      {
+         setDataFormat(value.intValue());
+      }
+   }
+
+   /**
+    * Set the data format.
+    * 
+    * @param    value
+    *           The data format.
+    */
+   @Override
+   public void setDataFormat(int value)
+   {
+      if (config.oleDataFormat == value)
+      {
+         return;
+      }
+            
+      if (isValidValue(value, CF_TEXT, CF_BITMAP, CF_METAFILE, CF_DIB, 
+               CF_PALETTE, CF_EMETAFILE, CF_FILES, CF_RTF))
+      {         
+         config.oleDataFormat = value;
+         pushWidgetAttr("oleDataFormat", config.oleDataFormat);
+      }
+      else
+      {
+         ErrorManager.recordOrShowError(5990, String.format(
+                  "Error occured while accessing component property/method: DataFormat\n"
+                  + "Invalid property value\n%s %s", type(), widgetName()), true);
+      }
+   }
+
+   /**
+    * Get the allowed effects.
+    * 
+    * @return   The allowed effects
+    */
+   @Override
+   public integer getAllowedEffects()
+   {
+      return new integer(config.oleAllowedEffects);
+   }
+
+   /**
+    * Set the allowed effects.
+    * 
+    * @param    value
+    *           The allowed effects
+    */
+   @Override
+   public void setAllowedEffects(integer value)
+   {
+      if (value.isUnknown())
+      {
+         ErrorManager.recordOrShowError(4083, String.format(
+               "Unable to assign UNKNOWN value to attribute ALLOWED-EFFECTS on %s %s", type(),
+                  widgetName()), false);
+      }
+      else
+      {
+         setAllowedEffects(value.intValue());
+      }
+   }
+
+   /**
+    * Set the allowed effects.
+    * 
+    * @param    value
+    *           The allowed effects
+    */
+   @Override
+   public void setAllowedEffects(int value)
+   {
+      if (config.oleAllowedEffects == value)
+      {
+         return;
+      }
+      
+      if (isValidValue(value, NONE, COPY, MOVE, SCROLL))
+      {
+         config.oleAllowedEffects = value;
+         pushWidgetAttr("oleAllowedEffects", config.oleAllowedEffects);
+      }
+      else
+      {
+         ErrorManager.recordOrShowError(5990, String.format(
+                  "Error occured while accessing component property/method: AllowedEffects\n"
+                  + "Invalid property value\n%s %s", type(), widgetName()), true);
+      }
+   }
+
+   /**
+    * Get the mouse button number.
+    * 
+    * @return   The mouse button number
+    */
+   @Override
+   public integer getMouseButton()
+   {
+      return new integer(config.mouseButton);
+   }
+
+   /**
+    * Get the mouse shift.
+    * 
+    * @return   The mouse shift
+    */
+   @Override
+   public integer getMouseShift()
+   {
+      return new integer(config.mouseShift);
+   }
+
+   /**
+    * Get the mouse X position.
+    * 
+    * @return   The mouse X position
+    */
+   @Override
+   public integer getMouseX()
+   {
+      return new integer(config.mouseX);
+   }
+
+   /**
+    * Get the mouse Y position.
+    * 
+    * @return   The mouse Y position
+    */
+   @Override
+   public integer getMouseY()
+   {
+      return new integer(config.mouseY);
+   }
+
+   /**
+    * Set the COM data.
+    * 
+    * @param    value
+    *           The COM data
+    */
+   @Override
+   public void setComData(comhandle value)
+   {
+   }
+
+   /**
+    * Get COM data.
+    * 
+    * @return   The COM data
+    */
+   @Override
+   public comhandle getComData()
+   {
+      return comData;
+   }
+}

=== modified file 'src/com/goldencode/p2j/ui/DynamicWidgetFactory.java'
--- src/com/goldencode/p2j/ui/DynamicWidgetFactory.java	2020-01-30 19:23:31 +0000
+++ src/com/goldencode/p2j/ui/DynamicWidgetFactory.java	2020-02-25 17:05:33 +0000
@@ -38,6 +38,7 @@
 ** 022 HC  20190614 Initial implementation of IMAGELIST widget.
 ** 023 MAG 20190920 Added PROGRESS-BAR widget.
 ** 024 HC  20200119 Added extension points to allow to externalize widget implementation.
+** 025 SBI 20200225 Added Calendar widget support.
 */
 
 /*
@@ -206,6 +207,7 @@
       widgetFactory.put(LegacyResource.BUTTON,         ButtonWidget.class);
       widgetFactory.put(LegacyResource.COMBO_BOX,      ComboBoxWidget.class);
       widgetFactory.put(LegacyResource.CONTROL_FRAME,  ControlFrameWidget.class);
+      widgetFactory.put(LegacyResource.CALENDAR, CalendarWidget.class);
       widgetFactory.put(LegacyResource.EDITOR,         EditorWidget.class);
       widgetFactory.put(LegacyResource.FILL_IN,        FillInWidget.class);
       widgetFactory.put(LegacyResource.FRAME,          FrameWidget.class);
@@ -568,6 +570,47 @@
    }
 
    /**
+    * Create a CALENDAR widget and save it in the given handle and in the unnamed pool, if 
+    * available.
+    * 
+    * @param    h
+    *           A handle where to save the create widget. Must be not-null.
+    */
+   public static void createCalendar(handle h)
+   {
+      createCalendar(h, (character) null);
+   }
+
+   /**
+    * Create a CALENDAR widget and save it in the given handle and in the specified pool 
+    * (which can be the unnamed pool if <code>widgetPool</code> is null).
+    * 
+    * @param    h
+    *           A handle where to save the create widget. Must be not-null.
+    * @param    widgetPool
+    *           The named widget pool where to save the widget. If <code>null</code>, the unnamed
+    *           widget pool will be used.
+    */
+   public static void createCalendar(handle h, character widgetPool)
+   {
+      create(LegacyResource.CALENDAR, h, widgetPool);
+   }
+
+   /**
+    * Create a CALENDAR widget and save it in the given handle and in the specified pool 
+    * (which can be the unnamed pool if <code>widgetPool</code> is null).
+    * 
+    * @param    h
+    *           A handle where to save the create widget. Must be not-null.
+    * @param    widgetPool
+    *           The named widget pool where to save the widget. If <code>null</code>, the unnamed
+    *           widget pool will be used.
+    */
+   public static void createCalendar(handle h, String widgetPool)
+   {
+      create(LegacyResource.CALENDAR, h, widgetPool);
+   }
+   /**
     * Create a DIALOG-BOX widget and save it in the given handle and in the unnamed pool, if 
     * available.
     * 

=== modified file 'src/com/goldencode/p2j/ui/OcxDragDrop.java'
--- src/com/goldencode/p2j/ui/OcxDragDrop.java	2019-12-12 09:45:54 +0000
+++ src/com/goldencode/p2j/ui/OcxDragDrop.java	2020-02-25 17:04:24 +0000
@@ -2,7 +2,7 @@
 ** Module   : OcxDragDrop.java
 ** Abstract : interface implemented by widgets which support OLE Drag and Drop.
 **
-** Copyright (c) 2019, Golden Code Development Corporation.
+** Copyright (c) 2019-2020, Golden Code Development Corporation.
 **
 ** -#- -I- --Date-- --------------------------------Description-----------------------------------
 ** 001 MAG 20191023 Created initial version.
@@ -71,7 +71,7 @@
     * Return whether this control can act as an OLE drop target.
     * OLEDropConstants - ccOLEDropManual=1 ccOLEDropNone=0
     * 
-    * @return OLE drop mode
+    * @return   The OLE drop mode
     */
    @LegacyMethod(name = "OLE-DROP-MODE")
    public integer getOleDropMode();
@@ -80,8 +80,8 @@
     * Set whether this control can act as an OLE drop target.
     * OLEDropConstants - ccOLEDropManual=1 ccOLEDropNone=0
     * 
-    * @param   value
-    *          OLE drop mode
+    * @param    value
+    *           The OLE drop mode
     */
    @LegacyMethod(name = "OLE-DROP-MODE")
    public void setOleDropMode(integer value);
@@ -90,8 +90,8 @@
     * Set whether this control can act as an OLE drop target.
     * OLEDropConstants - ccOLEDropManual=1 ccOLEDropNone=0
     * 
-    * @param   value 
-    *          OLE drop mode
+    * @param    value 
+    *           The OLE drop mode
     */
    @LegacyMethod(name = "OLE-DROP-MODE")
    public void setOleDropMode(int value);
@@ -103,183 +103,183 @@
    public void oleDrag();
    
    /**
-    * Get mouse effect.
+    * Get the mouse effect.
     * 
-    * @return mouse effect
+    * @return   The mouse effect
     */
    @LegacyMethod(name = "OLE-EFFECT")
    public integer getEffect();
    
    /**
-    * Set mouse effect.
+    * Set the mouse effect.
     * 
-    * @param   value
-    *          mouse effect
+    * @param    value
+    *           The mouse effect
     */
    @LegacyMethod(name = "OLE-EFFECT")
    public void setEffect(integer value);
 
    /**
-    * Set mouse effect.
+    * Set the mouse effect.
     * 
-    * @param   value
-    *          mouse effect
+    * @param    value
+    *           The mouse effect
     */
    @LegacyMethod(name = "OLE-EFFECT")
    public void setEffect(int value);
    
    /**
-    * Get OLE X coordinate in character units.
+    * Get the OLE X coordinate in character units.
     * 
-    * @return OLE X coordinate
+    * @return   The OLE X coordinate
     */
    @LegacyMethod(name = "OLE-X")
    public decimal getOleX();
    
    /**
-    * Set OLE X coordinate in character units.
+    * Set the OLE X coordinate in character units.
     * 
-    * @param   value
-    *          OLE X coordinate
+    * @param    value
+    *           The OLE X coordinate
     */
    @LegacyMethod(name = "OLE-X")
    public void setOleX(decimal value);
 
    /**
-    * Set OLE X coordinate in character units.
+    * Set the OLE X coordinate in character units.
     * 
-    * @param   value
-    *          OLE X coordinate
+    * @param    value
+    *           The OLE X coordinate
     */
    @LegacyMethod(name = "OLE-X")
    public void setOleX(double value);
 
    /**
-    * Get OLE X coordinate in character units.
+    * Get the OLE Y coordinate in character units.
     * 
-    * @return OLE Y coordinate
+    * @return   The OLE Y coordinate
     */
    @LegacyMethod(name = "OLE-Y")
    public decimal getOleY();
 
    /**
-    * Set OLE Y coordinate in character units.
+    * Set the OLE Y coordinate in character units.
     * 
-    * @param   value
-    *          OLE Y coordinate
+    * @param    value
+    *           The OLE Y coordinate
     */
    @LegacyMethod(name = "OLE-Y")
    public void setOleY(decimal value);
    
    /**
-    * Set OLE Y coordinate in character units.
+    * Set the OLE Y coordinate in character units.
     * 
-    * @param   value
-    *          OLE Y coordinate
+    * @param    value
+    *           The OLE Y coordinate
     */
    @LegacyMethod(name = "OLE-Y")
    public void setOleY(double value);
 
    /**
-    * Get OLE state.
+    * Get the OLE state.
     * 
-    * @return OLE state
+    * @return   The OLE state
     */
    @LegacyMethod(name = "OLE-STATE")
    public integer getState();
    
    /**
-    * Set OLE value state.
+    * Set the OLE value state.
     * 
-    * @param   value
-    *          OLE state
+    * @param    value
+    *           The OLE state
     */
    @LegacyMethod(name = "OLE-STATE")
    public void setState(integer value);
   
    /**
-    * Set OLE state.
+    * Set the OLE state.
     * 
-    * @param   value
-    *          OLE state
+    * @param    value
+    *           The OLE state
     */
    @LegacyMethod(name = "OLE-STATE")
    public void setState(int value);
 
    /**
-    * Get default cursors.
+    * Tests if the default cursors are used.
     * 
-    * @return default cursors
+    * @return   The default cursors flag
     */
    @LegacyMethod(name = "OLE-DEFAULT-CURSORS")
    public logical isDefaultCursors();
    
    /**
-    * Set default cursors.
+    * Set the default cursors flag.
     * 
-    * @param   value 
-    *          default cursors
+    * @param    value 
+    *           The default cursors flag
     */
    @LegacyMethod(name = "OLE-DEFAULT-CURSORS")
    public void setDefaultCursors(logical value);
 
    /**
-    * Set default cursors.
+    * Set the default cursors flag.
     * 
-    * @param   value
-    *          default cursors
+    * @param    value 
+    *           The default cursors flag
     */
    @LegacyMethod(name = "OLE-DEFAULT-CURSORS")
    public void setDefaultCursors(boolean value);
 
    /**
-    * Get data format.
+    * Get the data format.
     * 
-    * @return data format
+    * @return   The data format
     */
    @LegacyMethod(name = "OLE-DATA-FORMAT")
    public integer getDataFormat();
    
    /**
-    * Set data format.
+    * Set the data format.
     * 
-    * @param   value
-    *          data format.
+    * @param    value
+    *           The data format.
     */
    @LegacyMethod(name = "OLE-DATA_FORMAT")
    public void setDataFormat(integer value);
 
    /**
-    * Set data format.
+    * Set the data format.
     * 
-    * @param   value
-    *          data format.
+    * @param    value
+    *           The data format.
     */
    @LegacyMethod(name = "OLE-DATA_FORMAT")
    public void setDataFormat(int value);
 
    /**
-    * Get allowed effects.
+    * Get the allowed effects.
     * 
-    * @return allowed effects
+    * @return   The allowed effects
     */
    @LegacyMethod(name = "OLE-ALLOWED-EFFECTS")
    public integer getAllowedEffects();
    
    /**
-    * Set allowed effects.
+    * Set the allowed effects.
     * 
-    * @param   value
-    *          allowed effects
+    * @param    value
+    *           The allowed effects
     */
    @LegacyMethod(name = "OLE-ALLOWED-EFFECTS")
-
    public void setAllowedEffects(integer value);
+   
    /**
-    * Set allowed effects.
+    * Set the allowed effects.
     * 
-    * @param   value
-    *          allowed effects
+    * @param    value
+    *           The allowed effects
     */
    @LegacyMethod(name = "OLE-ALLOWED-EFFECTS")
    public void setAllowedEffects(int value);

